Public Class wizEmployee
    Private m_Privilege As String

    ' Set the new m_Privilege value.
    Private Sub radClerk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radClerk.Click
        m_Privilege = "Clerk"
    End Sub
    Private Sub radDispatcher_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radDispatcher.Click
        m_Privilege = "Dispatcher"
    End Sub
    Private Sub radSupervisor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radSupervisor.Click
        m_Privilege = "Supervisor"
    End Sub
    Private Sub radSystemAdministrator_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles radSystemAdministrator.Click
        m_Privilege = "System Administrator"
    End Sub

    ' The user moved to a new tab. Set the focus to the
    ' tab's first control.
    Private Sub tabPages_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tabPages.SelectedIndexChanged
        ' Find the control with smallest TabIndex 
        ' in this tab page.
        Dim best_index As Integer = 100000
        Dim best_control As Control = Nothing
        For Each ctl As Control In tabPages.SelectedTab.Controls
            If ctl.TabStop AndAlso ctl.TabIndex < best_index Then
                best_control = ctl
                best_index = ctl.TabIndex
            End If
        Next ctl

        ' Set focus to the control.
        If best_control IsNot Nothing Then best_control.Focus()
    End Sub

    ' Validate the data and close the wizard.
    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        ' Validate the data.
        If TextBoxIsEmpty(txtFirstName) Then Exit Sub
        If TextBoxIsEmpty(txtLastName) Then Exit Sub
        If TextBoxIsEmpty(txtPhone) Then Exit Sub

        If TextBoxIsEmpty(txtStreet) Then Exit Sub
        If TextBoxIsEmpty(txtCity) Then Exit Sub
        If TextBoxIsEmpty(txtState) Then Exit Sub
        If TextBoxIsEmpty(txtZip) Then Exit Sub

        If m_Privilege Is Nothing Then
            tabPages.SelectedTab = pagPrivilege
            MessageBox.Show("Please select a privilege level.", "Enter Value", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If

        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub

    ' If this TextBox holds a blank string, set focus to it,
    ' display its tab, display an error message, and return True.
    Private Function TextBoxIsEmpty(ByVal text_box As TextBox) As Boolean
        If text_box.Text.Length = 0 Then
            ' Display the tab containing the TextBox.
            tabPages.SelectedTab = DirectCast(text_box.Parent, TabPage)

            ' Set focus to the TextBox.
            text_box.Focus()

            ' Display an error message.
            Dim field_name As String = AddSpacesBeforeCaps(text_box.Name.Substring(3))
            MessageBox.Show("The " & field_name & _
                " must not be blank.", "Enter Value", _
                MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return True
        End If

        Return False
    End Function

    ' Insert spaces before the string's capital letters.
    Private Function AddSpacesBeforeCaps(ByVal txt As String) As String
        Dim txt_chars() As Char = txt.ToCharArray
        Dim result As String = txt_chars(0)

        For i As Integer = 1 To txt.Length - 1
            If (txt_chars(i) >= "A"c) And (txt_chars(i) <= "Z"c) Then
                result &= " "
            End If
            result &= txt_chars(i)
        Next i

        Return result
    End Function

    ' Return the Employee's XML text (the thing this wizard builds).
    Public Function EmployeeXml() As String
        Dim txt As String
        txt = "<Employee>" & vbCrLf
        txt &= "    <FirstName>" & Me.txtFirstName.Text & "</FirstName>" & vbCrLf
        txt &= "    <LastName>" & Me.txtLastName.Text & "</LastName>" & vbCrLf
        txt &= "    <Phone>" & Me.txtPhone.Text & "</Phone>" & vbCrLf
        txt &= "    <Street>" & Me.txtStreet.Text & "</Street>" & vbCrLf
        txt &= "    <City>" & Me.txtCity.Text & "</City>" & vbCrLf
        txt &= "    <State>" & Me.txtState.Text & "</State>" & vbCrLf
        txt &= "    <Zip>" & Me.txtZip.Text & "</Zip>" & vbCrLf
        txt &= "    <Privilege>" & m_Privilege & "</Privilege>" & vbCrLf
        txt &= "</Employee>" & vbCrLf

        Return txt
    End Function
End Class
